const output = document.getElementById("output");

const editor = CodeMirror.fromTextArea(
    document.getElementById("code"), {
        mode: {
            name: "python",
            version: 3,
            singleLineStringErrors: false,
        },
        lineNumbers: true,
        indentUnit: 4,
        matchBrackets: true
    }
);
editor.setValue("print('Grüße von der Python!')");

function addToOutput(stdout) {
    output.value += "\n>>> " + stdout;
}

async function main() {
    let pyodide = await loadPyodide({
        indexURL: "https://cdn.jsdelivr.net/pyodide/v0.21.3/full/",
    });
    output.value = pyodide.runPython(`
    import sys
    sys.version
  `);
    return pyodide;
}

let ready = main();

async function execPythonCode() {
    let pyodide = await ready;
    try {
        pyodide.runPython(`
      import io
      sys.stdout = io.StringIO()
    `);
        pyodide.runPython(editor.getValue());
        let stdout = pyodide.runPython("sys.stdout.getvalue()");
        addToOutput(stdout);
    } catch (err) {
        addToOutput(err);
    }
}